float startAngle = 0;
float angleVelocity = 0.2;
int xStep = 20;
int eSize = 10;
float ampl1, ampl2, ampl3, ampl4;

void setup() {
  fullScreen();
  fill(200, 0, 150, 80);
  background(0);
  smooth(4);
  
  ampl1 = height/4;
  ampl2 = height/8;
  ampl3 = height/16;
  ampl4 = height/32;
}

void draw() {
  fill(0, 40); // 20
  rect(0, 0, width, height);  
  float angle = startAngle;
  startAngle += 0.02;
  
  for (int x = 100; x < width - 100 ; x += 7) {
    //fill(lerpColor(0x50E9B5D2, 0x5035013F, x/float(width-200)));
    //float y = sin(angle) * ampl1 + ampl2 * sin(angle * 0.5) + ampl3 * sin(angle * 0.75) + ampl4 * sin(angle * 0.1);
    //ellipse(x, y + height/2, 50, 50); //eSize
    
    float shift = map(sin(frameCount/80), -1, 1, 1, 300);  // version 01
    //float shift = frameCount/float(80);                  // version 02
    
    // version 01 (0x99f6005b, 0x991557bd)     // version 02 (0x95081F37, 0x955FC9F3)
    // version 03 (0x9535013F, 0x95951556)    // version 04 (0x99F9CC6A, 0x99942E88
    fill(lerpColor(0x99f6005b, 0x991557bd, (x/float(width-200)) + random(-0.03, 0.03) ));
    float oscillate = sin(TWO_PI * frameCount / float(400)) * 0.1;
    float y2 = sin(angle * shift) * ampl1 
      + ampl2 * sin(angle * (0.160 + oscillate)) 
      + ampl3 * sin(angle * (0.17 + oscillate * 0.14)) 
      + ampl4 * sin(angle * 0.2);
    ellipse(x, y2 + height/2, 25, 25); //eSize 50 // 11
    
    angle += angleVelocity;
  }
  //saveFrame("Wave-mini-#####.png");
}

void keyPressed() {
  if(key == 's' || key == 'S') saveFrame("Wave-HD-####.png");
  if(key == 'p' || key == 'P') noLoop(); // pause
  if(key == 'r' || key == 'R') loop(); // resume
}